/* GStreamer
 * Copyright (C) <1999> Erik Walthinsen <omega@cse.ogi.edu>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <gst/gst_private.h>
#include <gst/gstversion.h>
#include <gst/gstplugin.h>

extern gboolean gst_mem_index_plugin_init 	(GModule *module, GstPlugin *plugin);
extern gboolean gst_file_index_plugin_init 	(GModule *module, GstPlugin *plugin);

static gboolean
plugin_init (GModule *module, GstPlugin *plugin)
{
  gboolean res = TRUE;

  res &= gst_mem_index_plugin_init (module, plugin);
  res &= gst_file_index_plugin_init (module, plugin);
  
  return res;
}

GstPluginDesc plugin_desc = {
  GST_VERSION_MAJOR,
  GST_VERSION_MINOR,
  "gstindexers",
  plugin_init
};

